package org.jastadd.ros2rag.tests;

import defaultOnlyRead.ast.MqttHandler;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Tag;

import java.io.IOException;
import java.util.concurrent.TimeUnit;

/**
 * Base class for tests ensuring running mqtt broker.
 *
 * @author rschoene - Initial contribution
 */
@Tag("mqtt")
public abstract class AbstractMqttTest {
  static boolean checkDone = false;
  static Boolean checkResult;

  @BeforeAll
  public static void checkMqttConnection() {
    if (!checkDone) {
      checkDone = true;
      try {
        checkResult = new MqttHandler()
            .dontSendWelcomeMessage()
            .setHost(TestUtils.getMqttHost())
            .waitUntilReady(2, TimeUnit.SECONDS);
      } catch (IOException e) {
        checkResult = false;
      }
    }
    if (!checkResult) {
      throw new IllegalStateException("Mqtt Broker not ready!");
    }
  }
}
